Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 2795)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 2796)
@@ -75,4 +75,5 @@
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6} = {958B43BC-CC5C-4FA2-8628-2B3B01D890B6}
 		{AB687BBE-1BFE-476B-906D-44237135431D} = {AB687BBE-1BFE-476B-906D-44237135431D}
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C} = {DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B} = {102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}
 		{EE2034D9-6E27-48A1-B855-42D45F69A4FC} = {EE2034D9-6E27-48A1-B855-42D45F69A4FC}
@@ -133,4 +134,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Netron-3.0.2672.12446", "HeuristicLab.ExtLibs\HeuristicLab.Netron\3.0.2672.12446\HeuristicLab.Netron-3.0.2672.12446\HeuristicLab.Netron-3.0.2672.12446.csproj", "{BB994448-2B21-4564-BB2E-38D8FFF8CF18}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Routing.TSP.Views-3.3", "HeuristicLab.Routing.TSP.Views\3.3\HeuristicLab.Routing.TSP.Views-3.3.csproj", "{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}"
 EndProject
 Global
@@ -578,4 +581,12 @@
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x64.ActiveCfg = Release|Any CPU
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x86.ActiveCfg = Release|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.Build.0 = Release|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.ActiveCfg = Release|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab 3.3/Files.txt
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2795)
+++ /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2796)
@@ -29,4 +29,5 @@
 HeuristicLab.Random\3.3:HeuristicLab.Random-3.3.dll 
 HeuristicLab.Routing.TSP\3.3:HeuristicLab.Routing.TSP-3.3.dll 
+HeuristicLab.Routing.TSP.Views\3.3:HeuristicLab.Routing.TSP.Views-3.3.dll 
 HeuristicLab.Selection\3.3:HeuristicLab.Selection-3.3.dll 
 HeuristicLab.Selection.OffspringSelection\3.3:HeuristicLab.Selection.OffspringSelection-3.3.dll 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.Designer.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.Designer.cs	(revision 2796)
@@ -120,5 +120,5 @@
       this.descriptionTextBox.Name = "descriptionTextBox";
       this.descriptionTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
-      this.descriptionTextBox.Size = new System.Drawing.Size(452, 103);
+      this.descriptionTextBox.Size = new System.Drawing.Size(452, 102);
       this.descriptionTextBox.TabIndex = 4;
       // 
@@ -127,5 +127,5 @@
       this.dataTypeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.dataTypeLabel.AutoSize = true;
-      this.dataTypeLabel.Location = new System.Drawing.Point(9, 426);
+      this.dataTypeLabel.Location = new System.Drawing.Point(12, 425);
       this.dataTypeLabel.Name = "dataTypeLabel";
       this.dataTypeLabel.Size = new System.Drawing.Size(60, 13);
@@ -138,8 +138,8 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.dataTypeTextBox.Enabled = false;
-      this.dataTypeTextBox.Location = new System.Drawing.Point(78, 423);
+      this.dataTypeTextBox.Location = new System.Drawing.Point(78, 422);
       this.dataTypeTextBox.Name = "dataTypeTextBox";
       this.dataTypeTextBox.ReadOnly = true;
-      this.dataTypeTextBox.Size = new System.Drawing.Size(423, 20);
+      this.dataTypeTextBox.Size = new System.Drawing.Size(422, 20);
       this.dataTypeTextBox.TabIndex = 6;
       // 
@@ -149,7 +149,7 @@
       this.setDataTypeButton.Enabled = false;
       this.setDataTypeButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Add;
-      this.setDataTypeButton.Location = new System.Drawing.Point(507, 421);
+      this.setDataTypeButton.Location = new System.Drawing.Point(506, 420);
       this.setDataTypeButton.Name = "setDataTypeButton";
-      this.setDataTypeButton.Size = new System.Drawing.Size(23, 23);
+      this.setDataTypeButton.Size = new System.Drawing.Size(24, 24);
       this.setDataTypeButton.TabIndex = 7;
       this.toolTip.SetToolTip(this.setDataTypeButton, "Set Data Type");
@@ -193,5 +193,4 @@
       this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
       this.Text = "Create Parameter";
-      this.Load += new System.EventHandler(this.CreateParameterDialog_Load);
       this.ResumeLayout(false);
       this.PerformLayout();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/CreateParameterDialog.cs	(revision 2796)
@@ -35,4 +35,7 @@
     protected TypeSelectorDialog typeSelectorDialog;
 
+    public TypeSelector ParameterTypeSelector {
+      get { return parameterTypeSelector; }
+    }
     public IParameter Parameter {
       get {
@@ -56,4 +59,5 @@
     public CreateParameterDialog() {
       InitializeComponent();
+      parameterTypeSelector.Configure(typeof(IParameter), false, true);
     }
 
@@ -70,8 +74,4 @@
       }
       okButton.Enabled = dataTypeTextBox.Tag != null;
-    }
-
-    protected virtual void CreateParameterDialog_Load(object sender, EventArgs e) {
-      parameterTypeSelector.Configure(typeof(IParameter), false, true);
     }
 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs	(revision 2796)
@@ -33,4 +33,5 @@
     protected override void Dispose(bool disposing) {
       if (disposing) {
+        if (typeSelectorDialog != null) typeSelectorDialog.Dispose();
         if (components != null) components.Dispose();
       }
@@ -54,10 +55,21 @@
       this.startButton = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.newProblemButton = new System.Windows.Forms.Button();
+      this.openProblemButton = new System.Windows.Forms.Button();
+      this.saveProblemButton = new System.Windows.Forms.Button();
+      this.newOperatorGraphButton = new System.Windows.Forms.Button();
+      this.openOperatorGraphButton = new System.Windows.Forms.Button();
+      this.saveOperatorGraphButton = new System.Windows.Forms.Button();
       this.tabControl = new System.Windows.Forms.TabControl();
       this.operatorGraphTabPage = new System.Windows.Forms.TabPage();
       this.globalScopeTabPage = new System.Windows.Forms.TabPage();
+      this.problemTabPage = new System.Windows.Forms.TabPage();
+      this.problemViewHost = new HeuristicLab.Core.Views.ViewHost();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
       this.tabControl.SuspendLayout();
       this.operatorGraphTabPage.SuspendLayout();
       this.globalScopeTabPage.SuspendLayout();
+      this.problemTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -87,8 +99,9 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.operatorGraphView.Caption = "Operator Graph";
-      this.operatorGraphView.Location = new System.Drawing.Point(6, 6);
+      this.operatorGraphView.Content = null;
+      this.operatorGraphView.Location = new System.Drawing.Point(6, 36);
       this.operatorGraphView.Name = "operatorGraphView";
-      this.operatorGraphView.Size = new System.Drawing.Size(782, 573);
-      this.operatorGraphView.TabIndex = 0;
+      this.operatorGraphView.Size = new System.Drawing.Size(782, 542);
+      this.operatorGraphView.TabIndex = 3;
       // 
       // scopeView
@@ -98,7 +111,8 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.scopeView.Caption = "Scope";
+      this.scopeView.Content = null;
       this.scopeView.Location = new System.Drawing.Point(6, 6);
       this.scopeView.Name = "scopeView";
-      this.scopeView.Size = new System.Drawing.Size(782, 573);
+      this.scopeView.Size = new System.Drawing.Size(782, 572);
       this.scopeView.TabIndex = 0;
       // 
@@ -107,7 +121,7 @@
       this.resetButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.resetButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Restart;
-      this.resetButton.Location = new System.Drawing.Point(58, 617);
+      this.resetButton.Location = new System.Drawing.Point(60, 616);
       this.resetButton.Name = "resetButton";
-      this.resetButton.Size = new System.Drawing.Size(23, 23);
+      this.resetButton.Size = new System.Drawing.Size(24, 24);
       this.resetButton.TabIndex = 3;
       this.toolTip.SetToolTip(this.resetButton, "Reset Engine");
@@ -120,7 +134,7 @@
       this.stopButton.Enabled = false;
       this.stopButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Stop;
-      this.stopButton.Location = new System.Drawing.Point(29, 617);
+      this.stopButton.Location = new System.Drawing.Point(30, 616);
       this.stopButton.Name = "stopButton";
-      this.stopButton.Size = new System.Drawing.Size(23, 23);
+      this.stopButton.Size = new System.Drawing.Size(24, 24);
       this.stopButton.TabIndex = 2;
       this.toolTip.SetToolTip(this.stopButton, "Stop Engine");
@@ -132,11 +146,77 @@
       this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.startButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Play;
-      this.startButton.Location = new System.Drawing.Point(0, 617);
+      this.startButton.Location = new System.Drawing.Point(0, 616);
       this.startButton.Name = "startButton";
-      this.startButton.Size = new System.Drawing.Size(23, 23);
+      this.startButton.Size = new System.Drawing.Size(24, 24);
       this.startButton.TabIndex = 1;
       this.toolTip.SetToolTip(this.startButton, "Start Engine");
       this.startButton.UseVisualStyleBackColor = true;
       this.startButton.Click += new System.EventHandler(this.startButton_Click);
+      // 
+      // newProblemButton
+      // 
+      this.newProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument;
+      this.newProblemButton.Location = new System.Drawing.Point(6, 6);
+      this.newProblemButton.Name = "newProblemButton";
+      this.newProblemButton.Size = new System.Drawing.Size(24, 24);
+      this.newProblemButton.TabIndex = 0;
+      this.toolTip.SetToolTip(this.newProblemButton, "Create New Problem");
+      this.newProblemButton.UseVisualStyleBackColor = true;
+      this.newProblemButton.Click += new System.EventHandler(this.newProblemButton_Click);
+      // 
+      // openProblemButton
+      // 
+      this.openProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Open;
+      this.openProblemButton.Location = new System.Drawing.Point(36, 6);
+      this.openProblemButton.Name = "openProblemButton";
+      this.openProblemButton.Size = new System.Drawing.Size(24, 24);
+      this.openProblemButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.openProblemButton, "Open Problem");
+      this.openProblemButton.UseVisualStyleBackColor = true;
+      this.openProblemButton.Click += new System.EventHandler(this.openProblemButton_Click);
+      // 
+      // saveProblemButton
+      // 
+      this.saveProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Save;
+      this.saveProblemButton.Location = new System.Drawing.Point(66, 6);
+      this.saveProblemButton.Name = "saveProblemButton";
+      this.saveProblemButton.Size = new System.Drawing.Size(24, 24);
+      this.saveProblemButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.saveProblemButton, "Save Problem");
+      this.saveProblemButton.UseVisualStyleBackColor = true;
+      this.saveProblemButton.Click += new System.EventHandler(this.saveProblemButton_Click);
+      // 
+      // newOperatorGraphButton
+      // 
+      this.newOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument;
+      this.newOperatorGraphButton.Location = new System.Drawing.Point(6, 6);
+      this.newOperatorGraphButton.Name = "newOperatorGraphButton";
+      this.newOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.newOperatorGraphButton.TabIndex = 0;
+      this.toolTip.SetToolTip(this.newOperatorGraphButton, "Create New Operator Graph");
+      this.newOperatorGraphButton.UseVisualStyleBackColor = true;
+      this.newOperatorGraphButton.Click += new System.EventHandler(this.newOperatorGraphButton_Click);
+      // 
+      // openOperatorGraphButton
+      // 
+      this.openOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Open;
+      this.openOperatorGraphButton.Location = new System.Drawing.Point(36, 6);
+      this.openOperatorGraphButton.Name = "openOperatorGraphButton";
+      this.openOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.openOperatorGraphButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.openOperatorGraphButton, "Open Operator Graph");
+      this.openOperatorGraphButton.UseVisualStyleBackColor = true;
+      this.openOperatorGraphButton.Click += new System.EventHandler(this.openOperatorGraphButton_Click);
+      // 
+      // saveOperatorGraphButton
+      // 
+      this.saveOperatorGraphButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Save;
+      this.saveOperatorGraphButton.Location = new System.Drawing.Point(66, 6);
+      this.saveOperatorGraphButton.Name = "saveOperatorGraphButton";
+      this.saveOperatorGraphButton.Size = new System.Drawing.Size(24, 24);
+      this.saveOperatorGraphButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.saveOperatorGraphButton, "Save Operator Graph");
+      this.saveOperatorGraphButton.UseVisualStyleBackColor = true;
+      this.saveOperatorGraphButton.Click += new System.EventHandler(this.saveOperatorGraphButton_Click);
       // 
       // tabControl
@@ -147,17 +227,21 @@
       this.tabControl.Controls.Add(this.operatorGraphTabPage);
       this.tabControl.Controls.Add(this.globalScopeTabPage);
+      this.tabControl.Controls.Add(this.problemTabPage);
       this.tabControl.Location = new System.Drawing.Point(0, 0);
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(802, 611);
-      this.tabControl.TabIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(802, 610);
+      this.tabControl.TabIndex = 3;
       // 
       // operatorGraphTabPage
       // 
+      this.operatorGraphTabPage.Controls.Add(this.saveOperatorGraphButton);
+      this.operatorGraphTabPage.Controls.Add(this.openOperatorGraphButton);
+      this.operatorGraphTabPage.Controls.Add(this.newOperatorGraphButton);
       this.operatorGraphTabPage.Controls.Add(this.operatorGraphView);
       this.operatorGraphTabPage.Location = new System.Drawing.Point(4, 22);
       this.operatorGraphTabPage.Name = "operatorGraphTabPage";
       this.operatorGraphTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.operatorGraphTabPage.Size = new System.Drawing.Size(794, 585);
+      this.operatorGraphTabPage.Size = new System.Drawing.Size(794, 584);
       this.operatorGraphTabPage.TabIndex = 0;
       this.operatorGraphTabPage.Text = "Operator Graph";
@@ -170,8 +254,48 @@
       this.globalScopeTabPage.Name = "globalScopeTabPage";
       this.globalScopeTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.globalScopeTabPage.Size = new System.Drawing.Size(794, 585);
+      this.globalScopeTabPage.Size = new System.Drawing.Size(794, 584);
       this.globalScopeTabPage.TabIndex = 1;
       this.globalScopeTabPage.Text = "Global Scope";
       this.globalScopeTabPage.UseVisualStyleBackColor = true;
+      // 
+      // problemTabPage
+      // 
+      this.problemTabPage.Controls.Add(this.saveProblemButton);
+      this.problemTabPage.Controls.Add(this.openProblemButton);
+      this.problemTabPage.Controls.Add(this.newProblemButton);
+      this.problemTabPage.Controls.Add(this.problemViewHost);
+      this.problemTabPage.Location = new System.Drawing.Point(4, 22);
+      this.problemTabPage.Name = "problemTabPage";
+      this.problemTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.problemTabPage.Size = new System.Drawing.Size(794, 584);
+      this.problemTabPage.TabIndex = 2;
+      this.problemTabPage.Text = "Problem";
+      this.problemTabPage.UseVisualStyleBackColor = true;
+      // 
+      // problemViewHost
+      // 
+      this.problemViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.problemViewHost.Content = null;
+      this.problemViewHost.Location = new System.Drawing.Point(6, 36);
+      this.problemViewHost.Name = "problemViewHost";
+      this.problemViewHost.Size = new System.Drawing.Size(782, 542);
+      this.problemViewHost.TabIndex = 3;
+      // 
+      // openFileDialog
+      // 
+      this.openFileDialog.DefaultExt = "hl";
+      this.openFileDialog.FileName = "Item";
+      this.openFileDialog.Filter = "HeuristicLab Files|*.hl|All Files|*.*";
+      this.openFileDialog.Title = "Open File";
+      // 
+      // saveFileDialog
+      // 
+      this.saveFileDialog.DefaultExt = "hl";
+      this.saveFileDialog.FileName = "Item";
+      this.saveFileDialog.Filter = "Uncompressed HeuristicLab Files|*.hl|HeuristicLab Files|*.hl|All Files|*.*";
+      this.saveFileDialog.FilterIndex = 2;
+      this.saveFileDialog.Title = "Save File";
       // 
       // EngineView
@@ -190,4 +314,5 @@
       this.operatorGraphTabPage.ResumeLayout(false);
       this.globalScopeTabPage.ResumeLayout(false);
+      this.problemTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -208,4 +333,14 @@
     protected System.Windows.Forms.TabPage operatorGraphTabPage;
     protected System.Windows.Forms.TabPage globalScopeTabPage;
+    protected System.Windows.Forms.TabPage problemTabPage;
+    protected ViewHost problemViewHost;
+    protected System.Windows.Forms.Button newProblemButton;
+    protected System.Windows.Forms.Button saveOperatorGraphButton;
+    protected System.Windows.Forms.Button openOperatorGraphButton;
+    protected System.Windows.Forms.Button newOperatorGraphButton;
+    protected System.Windows.Forms.Button saveProblemButton;
+    protected System.Windows.Forms.Button openProblemButton;
+    protected System.Windows.Forms.OpenFileDialog openFileDialog;
+    protected System.Windows.Forms.SaveFileDialog saveFileDialog;
 
   }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 2796)
@@ -30,4 +30,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.MainForm;
+using HeuristicLab.Persistence.Default.Xml;
 
 namespace HeuristicLab.Core.Views {
@@ -38,4 +39,5 @@
   [Content(typeof(IEngine), false)]
   public partial class EngineView : ItemView {
+    protected TypeSelectorDialog typeSelectorDialog;
     private int executionTimeCounter;
 
@@ -66,4 +68,5 @@
     protected override void DeregisterContentEvents() {
       Content.OperatorGraphChanged -= new EventHandler(Content_OperatorGraphChanged);
+      Content.ProblemChanged -= new EventHandler(Content_ProblemChanged);
       Content.Prepared -= new EventHandler(Content_Prepared);
       Content.Started -= new EventHandler(Content_Started);
@@ -81,4 +84,5 @@
       base.RegisterContentEvents();
       Content.OperatorGraphChanged += new EventHandler(Content_OperatorGraphChanged);
+      Content.ProblemChanged += new EventHandler(Content_ProblemChanged);
       Content.Prepared += new EventHandler(Content_Prepared);
       Content.Started += new EventHandler(Content_Started);
@@ -96,12 +100,21 @@
       stopButton.Enabled = false;
       if (Content == null) {
+        newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = false;
         operatorGraphView.Enabled = false;
         scopeView.Enabled = false;
-        startButton.Enabled = false;
-        resetButton.Enabled = false;
+        newProblemButton.Enabled = openProblemButton.Enabled = saveProblemButton.Enabled = false;
+        problemViewHost.Enabled = false;
+        startButton.Enabled = resetButton.Enabled = false;
         executionTimeTextBox.Enabled = false;
       } else {
+        newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = true;
         operatorGraphView.Content = Content.OperatorGraph;
+        operatorGraphView.Enabled = true;
         scopeView.Content = Content.GlobalScope;
+        scopeView.Enabled = true;
+        newProblemButton.Enabled = openProblemButton.Enabled = true;
+        saveProblemButton.Enabled = Content.Problem != null;
+        problemViewHost.Content = Content.Problem;
+        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         resetButton.Enabled = true;
@@ -118,10 +131,22 @@
         operatorGraphView.Content = Content.OperatorGraph;
     }
+    protected void Content_ProblemChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_ProblemChanged), sender, e);
+      else {
+        saveProblemButton.Enabled = Content.Problem != null;
+        problemViewHost.Content = Content.Problem;
+      }
+    }
     protected virtual void Content_Prepared(object sender, EventArgs e) {
       if (InvokeRequired)
         Invoke(new EventHandler(Content_Prepared), sender, e);
       else {
+        newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = true;
         operatorGraphView.Enabled = true;
         scopeView.Enabled = true;
+        newProblemButton.Enabled = openProblemButton.Enabled = true;
+        saveProblemButton.Enabled = Content.Problem != null;
+        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         stopButton.Enabled = false;
@@ -135,6 +160,9 @@
         Invoke(new EventHandler(Content_Started), sender, e);
       else {
+        newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = false;
         operatorGraphView.Enabled = false;
         scopeView.Enabled = false;
+        newProblemButton.Enabled = openProblemButton.Enabled = saveProblemButton.Enabled = false;
+        problemViewHost.Enabled = false;
         startButton.Enabled = false;
         stopButton.Enabled = true;
@@ -147,6 +175,10 @@
         Invoke(new EventHandler(Content_Stopped), sender, e);
       else {
+        newOperatorGraphButton.Enabled = openOperatorGraphButton.Enabled = saveOperatorGraphButton.Enabled = true;
         operatorGraphView.Enabled = true;
         scopeView.Enabled = true;
+        newProblemButton.Enabled = openProblemButton.Enabled = true;
+        saveProblemButton.Enabled = Content.Problem != null;
+        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         stopButton.Enabled = false;
@@ -171,4 +203,78 @@
 
     #region Button events
+    protected void newOperatorGraphButton_Click(object sender, EventArgs e) {
+      Content.OperatorGraph = new OperatorGraph();
+    }
+    protected void openOperatorGraphButton_Click(object sender, EventArgs e) {
+      openFileDialog.Title = "Open Operator Graph";
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        OperatorGraph operatorGraph = null;
+        try {
+          operatorGraph = XmlParser.Deserialize(openFileDialog.FileName) as OperatorGraph;
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+        if (operatorGraph == null)
+          MessageBox.Show(this, "Selected file does not contain an operator graph.", "Invalid File", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        else
+          Content.OperatorGraph = operatorGraph;
+      }
+    }
+    protected void saveOperatorGraphButton_Click(object sender, EventArgs e) {
+      saveFileDialog.Title = "Save Operator Graph";
+      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          if (saveFileDialog.FilterIndex == 1)
+            XmlGenerator.Serialize(Content.OperatorGraph, saveFileDialog.FileName, 0);
+          else
+            XmlGenerator.Serialize(Content.OperatorGraph, saveFileDialog.FileName, 9);
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+      }
+    }
+    protected void newProblemButton_Click(object sender, EventArgs e) {
+      if (typeSelectorDialog == null) {
+        typeSelectorDialog = new TypeSelectorDialog();
+      }
+      typeSelectorDialog.Caption = "Select Problem";
+      typeSelectorDialog.TypeSelector.Configure(typeof(IProblem), false, false);
+
+      if (typeSelectorDialog.ShowDialog(this) == DialogResult.OK) {
+        Content.Problem = (IProblem)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType();
+      }
+    }
+    protected void openProblemButton_Click(object sender, EventArgs e) {
+      openFileDialog.Title = "Open Problem";
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        IProblem problem = null;
+        try {
+          problem = XmlParser.Deserialize(openFileDialog.FileName) as IProblem;
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+        if (problem == null)
+          MessageBox.Show(this, "Selected file does not contain a problem.", "Invalid File", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        else
+          Content.Problem = problem;
+      }
+    }
+    protected void saveProblemButton_Click(object sender, EventArgs e) {
+      saveFileDialog.Title = "Save Problem";
+      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          if (saveFileDialog.FilterIndex == 1)
+            XmlGenerator.Serialize(Content.Problem, saveFileDialog.FileName, 0);
+          else
+            XmlGenerator.Serialize(Content.Problem, saveFileDialog.FileName, 9);
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+      }
+    }
     protected virtual void startButton_Click(object sender, EventArgs e) {
       Content.Start();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 2796)
@@ -53,4 +53,10 @@
   <ItemGroup>
     <None Include="HeuristicLabCoreViewsPlugin.cs.frame" />
+    <Compile Include="ValueParameterCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ValueParameterCollectionView.Designer.cs">
+      <DependentUpon>ValueParameterCollectionView.cs</DependentUpon>
+    </Compile>
     <Compile Include="ItemArrayView.cs">
       <SubType>UserControl</SubType>
@@ -107,4 +113,16 @@
     <Compile Include="OperatorTreeView.Designer.cs">
       <DependentUpon>OperatorTreeView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="OperatorView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="OperatorView.Designer.cs">
+      <DependentUpon>OperatorView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ProblemView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ProblemView.Designer.cs">
+      <DependentUpon>ProblemView.cs</DependentUpon>
     </Compile>
     <Compile Include="TypeSelectorDialog.cs">
@@ -223,4 +241,8 @@
       <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
       <Name>HeuristicLab.MainForm-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLabCoreViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLabCoreViewsPlugin.cs.frame	(revision 2795)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLabCoreViewsPlugin.cs.frame	(revision 2796)
@@ -37,4 +37,5 @@
   [PluginDependency("HeuristicLab.MainForm", "3.2")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.2")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabCoreViewsPlugin : PluginBase {
   }
